<?php

require_once('api/Okay.php');

class SendpulseBookAdmin extends Okay {

    public function fetch() {

        $api_user_id = $this->settings->send_pulse_userid;
        $api_secret = $this->settings->send_pulse_secret;
        $SP = $this->sendpulse->connect_sendpulse($api_user_id, $api_secret, 'session' );
        if(!empty($SP)){
            $this->design->assign('error',$SP);
        }
        $balance = $this->sendpulse->getBalance();
        $this->design->assign('balance',$balance);

        // Обработка действий
        if($this->request->method('post')) {
            // Действия с выбранными
            $ids = $this->request->post('check');

            if(is_array($ids)) {
                switch($this->request->post('action')) {
                    case 'delete': {
                        foreach($ids as $id) {
                            $test = $this->sendpulse->removeEmails($_GET['id'],$id);
                        }
                        break;
                    }
                }
            }
        }


        $book_info = $this->sendpulse->getBookInfo($this->request->get('id'));

        // Постраничная навигация
        $items_per_page = 30;
        // Текущая страница в постраничном выводе
        $current_page = $this->request->get('page', 'integer');
        // Если не задана, то равна 1
        $current_page = max(0, $current_page);
        $this->design->assign('current_page_num', $current_page);
        $this->design->assign('current_page', $current_page);

        $pages_num = ceil($book_info[0]->all_email_qty/$items_per_page);
        $this->design->assign('pages_count', $pages_num);
        $this->design->assign('total_pages_num', $pages_num);
        $this->design->assign('total_products_num', $book_info[0]->all_email_qty);

        $pg = $current_page;
        $limit = $items_per_page;


        $book_emails = $this->sendpulse->getEmailsFromBook($this->request->get('id'),$limit,$pg);

        $this->design->assign('book_info',$book_info);
        if($book_emails){
            $this->design->assign('book_emails',$book_emails);
        }
        return $this->body = $this->design->fetch('book.tpl');
    }

}
